; SMW Monty Mole - sprites 4D and 4E
;
; If the extra bit is clear, this will act like sprite 4D (ledge-dwelling mole),
; while if the extra bit is set, this will act like sprite 4E (ground-dwelling mole).
;
; The disassembly is Noobish Noobsicle's; I just added a subroutine and fixed a few typos.

ExecutePtr = $0086DF
GenerateTile = $00BEB0
GetRand = $01ACF9
GenericSprGfxRt2 = $0190B2

print "INIT ",pc
LDA $E4,x
AND #$10
STA $151C,x
RTL

print "MAIN ",pc
PHB
PHK
PLB
JSR MontyMoleMain
PLB
RTL

MontyMoleMain:

JSR SubOffscreen0Bnk1   
LDA $C2,X     
JSL ExecutePtr          

Ptrs01E2D8:
dw CODE_01E2E0           
dw CODE_01E309           
dw CODE_01E37F           
dw CODE_01E393           

CODE_01E2E0:
JSR SubHorizPos         		
LDA $0F                   
CLC                       
ADC #$60                
CMP #$C0                
BCS CODE_01E305           
LDA $15A0,X 
BNE CODE_01E305           
INC $C2,X     
LDY $0DB3               
LDA $1F11,Y             
TAY                       
LDA #$68                
CPY #$01                
BEQ CODE_01E302           
LDA #$20    
CODE_01E302:            
STA $1540,X             
CODE_01E305:
JSR GET_DRAW_INFO     		
RTS                       ; Return 

CODE_01E309:
LDA $1540,X             
ORA $15D0,X             
BNE CODE_01E343           
INC $C2,X     
LDA #$B0                
STA $AA,X    
JSR IsSprOffScreen      		
BNE CODE_01E320           
TAY                       
JSR CODE_0199E1         		
CODE_01E320:
JSR FaceMario
LDA $7FAB10,x
AND #$04         
BEQ CODE_01E343           
LDA $E4,X       ; \ $9A = Sprite X position 
STA $9A          ;  | for block creation 
LDA $14E0,X     ;  | 
STA $9B          ; / 
LDA $D8,X       ; \ $98 = Sprite Y position 
STA $98          ;  | for block creation 
LDA $14D4,X     ;  | 
STA $99          ; / 
LDA #$08                ; \ Block to generate = Mole hole 
STA $9C        ; / 
JSL GenerateTile        
CODE_01E343:
LDA $7FAB10,x
AND #$04
BNE CODE_01E363           
LDA $14     
LSR #4                     
AND #$01                
TAY                       
LDA DATA_01E35F,Y       
STA $1602,X             
LDA DATA_01E361,Y       
JSL $018042
RTS                       ; Return 


DATA_01E35F:
db $01,$02

DATA_01E361:
db $00,$05

CODE_01E363:
LDA $14     
ASL #2                      
AND #$C0                
ORA #$31                
STA $15F6,X     
LDA #$03                
STA $1602,X             
JSL GenericSprGfxRt2
LDA $15F6,X     
AND #$3F                
STA $15F6,X     
RTS                       ; Return 

CODE_01E37F:
JSR CODE_01E3EF         		
LDA #$02                
STA $1602,X             
JSR IsOnGround          		
BEQ Return01E38E          
INC $C2,X     
Return01E38E:
RTS                       ; Return 


DATA_01E38F:
db $10,$F0

DATA_01E391:
db $18,$E8

CODE_01E393:
JSR CODE_01E3EF         		
LDA $151C,X             
BNE CODE_01E3C7h        		
JSR SetAnimationFrame   		
JSR SetAnimationFrame   
JSL GetRand             
AND #$01                
BNE Return01E3C6          
JSR FaceMario           		
LDA $B6,X    
CMP DATA_01E391,Y       
BEQ Return01E3C6          
CLC                       
ADC DATA_01EBB4,Y       		
STA $B6,X    
TYA                       
LSR                       
ROR                       
EOR $B6,X    
BPL Return01E3C6          
JSR CODE_01804E         		
JSR SetAnimationFrame   		
Return01E3C6:
RTS                       ; Return 

SubHorizPos:
LDY #$00                
LDA $D1                   
SEC                       
SBC $E4,X       
STA $0F                   
LDA $D2                   
SBC $14E0,X     
BPL Return01AD41          
INY                       
Return01AD41:
RTS                       ; Return 

CODE_01E3C7h:
JMP CODE_01E3C7

IsSprOffScreen:
LDA $15A0,X ; \ A = Current sprite is offscreen 
ORA $186C,X ; /  
RTS                       ; Return 

FaceMario:
JSR SubHorizPos         
TYA                       
STA $157C,X     
RTS          

IsOnGround:
LDA $1588,X  		; \ Set A to bit 2 of 
AND #$04                ; / current sprite's Position Status 
RTS                     ; Return              

SetAnimationFrame:
INC $1570,X               
LDA $1570,X               ; \ Change animation image every 8 cycles 
LSR                       ;  | 
LSR                       ;  | 
LSR                       ;  | 
AND #$01                  ;  | 
STA $1602,X               ; / 
RTS                       ; Return 

DATA_01EBB4:
db $01,$FF,$01,$00,$FF,$00,$20,$E0,$0A,$0E

CODE_01E3EF:
LDA $64                   
PHA                       
LDA $1540,X             
BEQ CODE_01E3FB           
LDA #$10                
STA $64                   
CODE_01E3FB:
JSL GenericSprGfxRt2
PLA                       
STA $64                   
LDA $9D                   ; \ Branch if sprites locked 
BNE CODE_01E41C           ; / 
JSL $01803A
JSL $01802A     
LDA $1588,x
BIT #$04
BEQ CODE_01E413           
JSR SetSomeYSpeed     
CODE_01E413:
LDA $1588,x
BIT #$03 
BEQ Return01E41B          
JSR FlipSpriteDir       
Return01E41B:
RTS                       ; Return 

CODE_01E41C:
PLA                       
PLA                       
RTS                       ; Return 

SetSomeYSpeed:
LDA $1588,X  
BMI CODE_019A10           
LDA #$00                ; \ Sprite Y speed = #$00 or #$18 
LDY $15B8,X             ;  | Depending on 15B8,x ??? 
BEQ CODE_019A12           ;  | 
CODE_019A10:
LDA #$18                ;  | 
CODE_019A12:
STA $AA,X    ; / 
Return019A14:
RTS                       ; Return 

FlipSpriteDir:
LDA $15AC,X             ; \ Return if turning timer is set 
BNE Return0190B1          ; / 
LDA #$08                ; \ Set turning timer 
STA $15AC,X             ; / 
LDA $B6,X    ; \ Invert speed 
EOR #$FF                ;  | 
INC A                     ;  | 
STA $B6,X    ; / 
LDA $157C,X     ; \ Flip sprite direction 
EOR #$01                ;  | 
STA $157C,X     ; / 
Return0190B1:
RTS                       ; Return 

CODE_01804E:
LDA $1588,X  ; \ Branch if in air 
BEQ Return018072          ; / 
LDA $13      
AND #$03                
ORA $86                   
BNE Return018072          
LDA #$04                
STA $00                   
LDA #$0A                
STA $01                   
JSR IsSprOffScreen      
BNE Return018072          
LDY #$03                
CODE_01806A:
LDA $17C0,Y             
BEQ CODE_018073           
DEY                       
BPL CODE_01806A           
Return018072:
RTS                       ; Return 

CODE_018073:
LDA #$03                
STA $17C0,Y             
LDA $E4,X       
ADC $00                   
STA $17C8,Y             
LDA $D8,X       
ADC $01                   
STA $17C4,Y             
LDA #$13                
STA $17CC,Y             
RTS                       ; Return 

CODE_01E3C7:
JSR IsOnGround          
BEQ CODE_01E3E9           
JSR SetAnimationFrame   
JSR SetAnimationFrame   
LDY $157C,X     
LDA DATA_01E38F,Y       
STA $B6,X    
LDA $1558,X             
BNE Return01E3E8          
LDA #$50                
STA $1558,X             
LDA #$D8                
STA $AA,X    
Return01E3E8:
RTS                       ; Return 

CODE_01E3E9:
LDA #$01                
STA $1602,X             
RTS                       ; Return 

CODE_0199E1:
JSR IsSprOffScreen      ; \ Return if off screen 
BNE Return019A03          ; /
LDA $E4,X       ; \ Store Y position in $9A-$9B 
STA $9A          ;  | 
LDA $14E0,X     ;  | 
STA $9B          ; / 
LDA $D8,X       ; \ Store X position in $98-$99 
STA $98          ;  | 
LDA $14D4,X     ;  | 
STA $99          ; / 
PHB                       ; \ Shatter the brick 
LDA #$02                ;  | 
PHA                       ;  | 
PLB                       ;  | 
TYA                       ;  | 
JSL $028663               ;  | 
PLB                       ; / 
Return019A03:
RTS                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1:
              db $0C,$1C
TABLE2:
              db $01,$02

Table3:              db $40,$B0
Table6:              db $01,$FF
Table4:              db $30,$C0,$A0,$C0,$A0,$F0,$60,$90,$30,$C0,$A0,$80,$A0,$40,$60,$B0
Table5:              db $01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$00,$01,$FF

GET_DRAW_INFO:
       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X:
         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC #$0040            ;  |
                    CMP #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP:
      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y:
         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID:
             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

SubOffscreen0Bnk1:
LDA #$00

SubOffscreenMain:

STA $03

JSR SubIsOffscreen
BEQ Return2

LDA $5B
LSR
BCS VerticalLevel
LDA $D8,x
CLC
ADC #$50
LDA $14D4,x
ADC #$00
CMP #$02
BPL EraseSprite
LDA $167A,x
AND #$04
BNE Return2
LDA $13
AND #$01
ORA $03
STA $01
TAY
LDA $1A
CLC
ADC Table4,y
ROL $00
CMP $E4,x
PHP
LDA $1B
LSR $00
ADC Table5,y
PLP
SBC $14E0,x
STA $00
LSR $01
BCC Label20
EOR #$80
STA $00
Label20:
LDA $00
BPL Return2

EraseSprite:
LDA $14C8,x
CMP #$08
BCC KillSprite
LDY $161A,x
CPY #$FF
BEQ KillSprite
LDA #$00
STA $1938,y
KillSprite:
STZ $14C8,x
Return2:
RTS

VerticalLevel:

LDA $167A,x
AND #$04
BNE Return2
LDA $13
LSR
BCS Return2
AND #$01
STA $01
TAY
LDA $1C
CLC
ADC Table3,y
ROL $00
CMP $D8,x
PHP
LDA $1D
LSR $00
ADC Table6,y
PLP
SBC $14D4,x
STA $00
LDY $02
BEQ Label22
EOR #$80
STA $00
Label22:
LDA $00
BPL Return2
BMI EraseSprite

SubIsOffscreen:
LDA $15A0,x
ORA $186C,x
RTS